## org.apache.xerces.readers
Interface XMLEntityHandler.EntityReader

All Known Implementing Classes:
  org.apache.xerces.readers.XMLEntityReader

Enclosing class:
  XMLEntityHandler

public static interface XMLEntityHandler.EntityReader

This is the interface for scanners to process input data from entities without needing to know the details of the underlying storage of those entities, or their encodings. The methods in this interface have been refined over time to a rough balance between keeping the XML grammar dependent code within the scanner classes, and allowing high performance processing of XML documents.

Method Summary
`int` `addString(int offset, int length)` Add a string to the `StringPool` from the characters scanned using this reader as described by `offset` and `length`.
`int` `addSymbol(int offset, int length)` Add a symbol to the `StringPool` from the characters scanned using this reader as described by `offset` and `length`.
`void` `append(XMLEntityHandler.CharBuffer charBuffer, int offset, int length)` Append the characters processed by this reader associated with `offset` and `length` to the `CharBuffer`.
`int` `currentOffset()` Return the current offset within this reader.
`int` `getColumnNumber()` Return the column number of the current position within the document that we are processing.
`boolean` `getInCDSect()` This method is provided for scanner implementations.
`int` `getLineNumber()` Return the line number of the current position within the document that we are processing.
`boolean` `lookingAtChar(char ch, boolean skipPastChar)` Test that the current character is a `ch` character.
`boolean` `lookingAtSpace(boolean skipPastChar)` Test that the current character is a whitespace character.
`boolean` `lookingAtValidChar(boolean skipPastChar)` Test that the current character is valid.
`int` `scanAttValue(char qchar, boolean asSymbol)` Scan an attribute value.
`int` `scanCharRef(boolean isHexadecimal)` Scan a character reference.
`int` `scanContent(QName element)` Skip through the input while we are looking at character data.
`int` `scanEntityValue(int qchar, boolean createString)` Scan an entity value.
`boolean` `scanExpectedName(char fastcheck, StringPool.CharArrayRange expectedName)` Scan the name that is expected at the current position in the document.
`int` `scanInvalidChar()` Scan an invalid character.
`int` `scanName(char fastcheck)` Add a sequence of characters that match the XML definition of a Name to the `StringPool`.
`void` `scanQName(char fastcheck, QName qname)` Add a sequence of characters that match the XML Namespaces definition of a QName to the `StringPool`.
`int` `scanStringLiteral()` Scan a string literal.
`void` `setInCDSect(boolean inCDSect)` This method is provided for scanner implementations.
`void` `skipPastName(char fastcheck)` Skip past a sequence of characters that match the XML definition of a Name.
`void` `skipPastNmtoken(char fastcheck)` Skip past a sequence of characters that match the XML definition of an Nmtoken.
`void` `skipPastSpaces()` Skip past whitespace characters starting at the current position.
`boolean` `skippedString(char[] s)` Skip past a sequence of characters that matches the specified character array.
`void` `skipToChar(char ch)` Advance through the input data up to the next `ch` character.

Method Detail

### currentOffset

    public int currentOffset()

  Return the current offset within this reader.
  Returns:
    The offset.

### getLineNumber

    public int getLineNumber()

  Return the line number of the current position within the document that we are processing.
  Returns:
    The current line number.

### getColumnNumber

    public int getColumnNumber()

  Return the column number of the current position within the document that we are processing.
  Returns:
    The current column number.

### setInCDSect

    public void setInCDSect(boolean inCDSect)

  This method is provided for scanner implementations.

### getInCDSect

    public boolean getInCDSect()

  This method is provided for scanner implementations.

### append

    public void append(XMLEntityHandler.CharBuffer charBuffer,
                       int offset,
                       int length)

  Append the characters processed by this reader associated with `offset` and `length` to the `CharBuffer`.
  Parameters:
    `charBuffer` - The `CharBuffer` to append the characters to.
    `offset` - The offset within this reader where the copy should start.
    `length` - The length within this reader where the copy should stop.

### addString

    public int addString(int offset,
                         int length)

  Add a string to the `StringPool` from the characters scanned using this reader as described by `offset` and `length`.
  Parameters:
    `offset` - The offset within this reader where the characters start.
    `length` - The length within this reader where the characters end.
  Returns:
    The `StringPool` handle for the string.

### addSymbol

    public int addSymbol(int offset,
                         int length)

  Add a symbol to the `StringPool` from the characters scanned using this reader as described by `offset` and `length`.
  Parameters:
    `offset` - The offset within this reader where the characters start.
    `length` - The length within this reader where the characters end.
  Returns:
    The `StringPool` handle for the symbol.

### lookingAtChar

    public boolean lookingAtChar(char ch,
                                 boolean skipPastChar)
                          throws java.lang.Exception

  Test that the current character is a `ch` character.
  Parameters:
    `ch` - The character to match against.
    `skipPastChar` - If `true`, we advance past the matched character.
  Returns:
    `true` if the current character is a `ch` character; `false` otherwise.
  Throws:
    java.lang.Exception -

### lookingAtValidChar

    public boolean lookingAtValidChar(boolean skipPastChar)
                               throws java.lang.Exception

  Test that the current character is valid.
  Parameters:
    `skipPastChar` - If `true`, we advance past the valid character.
  Returns:
    `true` if the current character is valid; `false` otherwise.
  Throws:
    java.lang.Exception -

### lookingAtSpace

    public boolean lookingAtSpace(boolean skipPastChar)
                           throws java.lang.Exception

  Test that the current character is a whitespace character.
  Parameters:
    `skipPastChar` - If `true`, we advance past the whitespace character.
  Returns:
    `true` if the current character is whitespace; `false` otherwise.
  Throws:
    java.lang.Exception -

### skipToChar

    public void skipToChar(char ch)
                    throws java.lang.Exception

  Advance through the input data up to the next `ch` character.
  Parameters:
    `ch` - The character to search for.
  Throws:
    java.lang.Exception -

### skipPastSpaces

    public void skipPastSpaces()
                        throws java.lang.Exception

  Skip past whitespace characters starting at the current position.
  Throws:
    java.lang.Exception -

### skipPastName

    public void skipPastName(char fastcheck)
                      throws java.lang.Exception

  Skip past a sequence of characters that match the XML definition of a Name.
  Throws:
    java.lang.Exception -

### skipPastNmtoken

    public void skipPastNmtoken(char fastcheck)
                         throws java.lang.Exception

  Skip past a sequence of characters that match the XML definition of an Nmtoken.
  Throws:
    java.lang.Exception -

### skippedString

    public boolean skippedString(char[] s)
                          throws java.lang.Exception

  Skip past a sequence of characters that matches the specified character array.
  Parameters:
    `s` - The characters to match.
  Returns:
    `true` if the current character is valid; `false` otherwise.
  Throws:
    java.lang.Exception -

### scanInvalidChar

    public int scanInvalidChar()
                        throws java.lang.Exception

  Scan an invalid character.
  Returns:
    The invalid character as an integer, or -1 if there was a bad encoding.
  Throws:
    java.lang.Exception -

### scanCharRef

    public int scanCharRef(boolean isHexadecimal)
                    throws java.lang.Exception

  Scan a character reference.
  Returns:
    The value of the character, or one of the following error codes: CHARREF_RESULT_SEMICOLON_REQUIRED CHARREF_RESULT_INVALID_CHAR CHARREF_RESULT_OUT_OF_RANGE
  Throws:
    java.lang.Exception -

### scanStringLiteral

    public int scanStringLiteral()
                          throws java.lang.Exception

  Scan a string literal.
  Returns:
    The `StringPool` handle for the string that was scanned, or one of the following error codes: STRINGLIT_RESULT_QUOTE_REQUIRED STRINGLIT_RESULT_INVALID_CHAR
  Throws:
    java.lang.Exception -

### scanAttValue

    public int scanAttValue(char qchar,
                            boolean asSymbol)
                     throws java.lang.Exception

  Scan an attribute value.
  Parameters:
    `qchar` - The initial quote character, either a single or double quote.
  Returns:
    The `StringPool` handle for the string that was scanned, or one of the following error codes: ATTVALUE_RESULT_COMPLEX ATTVALUE_RESULT_LESSTHAN ATTVALUE_RESULT_INVALID_CHAR
  Throws:
    java.lang.Exception -

### scanEntityValue

    public int scanEntityValue(int qchar,
                               boolean createString)
                        throws java.lang.Exception

  Scan an entity value.
  Parameters:
    `qchar` - The initial quote character, either a single or double quote.
  Returns:
    The `StringPool` handle for the string that was scanned, or one of the following error codes: ENTITYVALUE_RESULT_FINISHED ENTITYVALUE_RESULT_REFERENCE ENTITYVALUE_RESULT_PEREF ENTITYVALUE_RESULT_INVALID_CHAR ENTITYVALUE_RESULT_END_OF_INPUT
  Throws:
    java.lang.Exception -

### scanName

    public int scanName(char fastcheck)
                 throws java.lang.Exception

  Add a sequence of characters that match the XML definition of a Name to the `StringPool`. If we find a name at the current position we will add it to the `StringPool` as a symbol and will return the string pool handle for that symbol to the caller.
  Parameters:
    `fastcheck` - A character that is not a legal name character that is provided as a hint to the reader of a character likely to terminate the Name.
  Returns:
    The `StringPool` handle for the name that was scanned, or -1 if a name was not found at the current position within the input data.
  Throws:
    java.lang.Exception -

### scanExpectedName

    public boolean scanExpectedName(char fastcheck,
                                    StringPool.CharArrayRange expectedName)
                             throws java.lang.Exception

  Scan the name that is expected at the current position in the document. This method is invoked when we are scanning the element type in an end tag that must match the element type in the corresponding start tag.
  Parameters:
    `fastcheck` - A character that is not a legal name character that is provided as a hint to the reader of a character likely to terminate the Name.
    `expectedName` - The characters of the name we expect.
  Returns:
    `true` if we scanned the name we expected to find; otherwise `false` if we did not.
  Throws:
    java.lang.Exception -

### scanQName

    public void scanQName(char fastcheck,
                          QName qname)
                   throws java.lang.Exception

  Add a sequence of characters that match the XML Namespaces definition of a QName to the `StringPool`. If we find a QName at the current position we will add it to the `StringPool` and will return the string pool handle of that QName to the caller.
  Parameters:
    `fastcheck` - A character that is not a legal name character that is provided as a hint to the reader of a character likely to terminate the Name.
  Throws:
    java.lang.Exception -

### scanContent

    public int scanContent(QName element)
                    throws java.lang.Exception

  Skip through the input while we are looking at character data.
  Parameters:
    `elementType` - The element type handle in the StringPool.
  Returns:
    One of the following result codes: CONTENT_RESULT_START_OF_PI CONTENT_RESULT_START_OF_COMMENT CONTENT_RESULT_START_OF_CDSECT CONTENT_RESULT_END_OF_CDSECT CONTENT_RESULT_START_OF_ETAG CONTENT_RESULT_MATCHING_ETAG CONTENT_RESULT_START_OF_ELEMENT CONTENT_RESULT_START_OF_CHARREF CONTENT_RESULT_START_OF_ENTITYREF CONTENT_RESULT_INVALID_CHAR CONTENT_RESULT_MARKUP_NOT_RECOGNIZED CONTENT_RESULT_MARKUP_END_OF_INPUT CONTENT_RESULT_REFERENCE_END_OF_INPUT
  Throws:
    java.lang.Exception -

Copyright © 1999-2001 Apache XML Project. All Rights Reserved.